3 # Copyright (c) 2005 Junio C Hamano
5 # Fetch one or more remote refs and merge it/them into the current HEAD.
7 USAGE='[-n | --no-stat] [--[no-]commit] [--[no-]squash] [--[no-]ff] [-s strategy]... [<fetch-options>] <repo> <head>...'
8 LONG_USAGE='Fetch one or more remote refs and merge it/them into the current HEAD.'
13 set_reflog_action "pull${1+ $*}"
14 require_work_tree_exists
19 git diff-index --cached --name-status -r --ignore-submodules HEAD --
20 if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then
21 die "$(gettext "Pull is not possible because you have unmerged files.
22 Please, fix them up in the work tree, and then use 'git add/rm <file>'
23 as appropriate to mark resolution, or use 'git commit -a'.")"
25 die "$(gettext "Pull is not possible because you have unmerged files.")"
30 if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then
31 die "$(gettext "You have not concluded your merge (MERGE_HEAD exists).
32 Please, commit your changes before you can merge.")"
34 die "$(gettext "You have not concluded your merge (MERGE_HEAD exists).")"
38 test -z "$(git ls-files -u)" || die_conflict
39 test -f "$GIT_DIR/MERGE_HEAD" && die_merge
41 strategy_args= diffstat= no_commit= squash= no_ff= ff_only=
42 log_arg= verbosity= progress= recurse_submodules=
44 curr_branch=$(git symbolic-ref -q HEAD)
45 curr_branch_short="${curr_branch#refs/heads/}"
46 rebase=$(git config --bool branch.$curr_branch_short.rebase)
49 rebase=$(git config --bool pull.rebase)
56 verbosity="$verbosity -q" ;;
58 verbosity="$verbosity -v" ;;
60 progress=--progress ;;
62 progress=--no-progress ;;
63 -n|--no-stat|--no-summary)
69 --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
70 no_commit=--no-commit ;;
71 --c|--co|--com|--comm|--commi|--commit)
77 --sq|--squ|--squa|--squas|--squash)
79 --no-sq|--no-squ|--no-squa|--no-squas|--no-squash)
87 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
88 --strateg=*|--strategy=*|\
89 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
92 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
99 strategy_args="${strategy_args}-s $strategy "
106 xx="-X $(git rev-parse --sq-quote "$2")"
109 xx=$(git rev-parse --sq-quote "$1") ;;
111 merge_args="$merge_args$xx "
113 -r|--r|--re|--reb|--reba|--rebas|--rebase)
116 --no-r|--no-re|--no-reb|--no-reba|--no-rebas|--no-rebase)
119 --recurse-submodules)
120 recurse_submodules=--recurse-submodules
122 --recurse-submodules=*)
123 recurse_submodules="$1"
125 --no-recurse-submodules)
126 recurse_submodules=--no-recurse-submodules
128 --d|--dr|--dry|--dry-|--dry-r|--dry-ru|--dry-run)
135 # Pass thru anything that may be meant for fetch.
142 error_on_no_merge_candidates () {
147 -t|--t|--ta|--tag|--tags)
148 echo "Fetching tags only, you probably meant:"
149 echo " git fetch --tags"
154 if test true = "$rebase"
163 curr_branch=${curr_branch#refs/heads/}
164 upstream=$(git config "branch.$curr_branch.merge")
165 remote=$(git config "branch.$curr_branch.remote")
167 if [ $# -gt 1 ]; then
168 if [ "$rebase" = true ]; then
169 printf "There is no candidate for rebasing against "
171 printf "There are no candidates for merging "
173 echo "among the refs that you just fetched."
174 echo "Generally this means that you provided a wildcard refspec which had no"
175 echo "matches on the remote end."
176 elif [ $# -gt 0 ] && [ "$1" != "$remote" ]; then
177 echo "You asked to pull from the remote '$1', but did not specify"
178 echo "a branch. Because this is not the default configured remote"
179 echo "for your current branch, you must specify a branch on the command line."
180 elif [ -z "$curr_branch" -o -z "$upstream" ]; then
182 error_on_missing_default_upstream "pull" $op_type $op_prep \
183 "git pull <remote> <branch>"
185 echo "Your configuration specifies to $op_type $op_prep the ref '${upstream#refs/heads/}'"
186 echo "from the remote, but no such ref was fetched."
191 test true = "$rebase" && {
192 if ! git rev-parse -q --verify HEAD >/dev/null
194 # On an unborn branch
195 if test -f "$GIT_DIR/index"
197 die "$(gettext "updating an unborn branch with changes added to the index")"
200 require_clean_work_tree "pull with rebase" "Please commit or stash them."
203 . git-parse-remote &&
204 remoteref="$(get_remote_merge_branch "$@" 2>/dev/null)" &&
205 oldremoteref="$(git rev-parse -q --verify "$remoteref")" &&
206 for reflog in $(git rev-list -g $remoteref 2>/dev/null)
208 if test "$reflog" = "$(git merge-base $reflog $curr_branch)"
210 oldremoteref="$reflog"
215 orig_head=$(git rev-parse -q --verify HEAD)
216 git fetch $verbosity $progress $dry_run $recurse_submodules --update-head-ok "$@" || exit 1
217 test -z "$dry_run" || exit 0
219 curr_head=$(git rev-parse -q --verify HEAD)
220 if test -n "$orig_head" && test "$curr_head" != "$orig_head"
222 # The fetch involved updating the current branch.
224 # The working tree and the index file is still based on the
225 # $orig_head commit, but we are merging into $curr_head.
226 # First update the working tree to match $curr_head.
228 eval_gettextln "Warning: fetch updated the current branch head.
229 Warning: fast-forwarding your working tree from
230 Warning: commit \$orig_head." >&2
231 git update-index -q --refresh
232 git read-tree -u -m "$orig_head" "$curr_head" ||
233 die "$(eval_gettext "Cannot fast-forward your working tree.
234 After making sure that you saved anything precious from
235 $ git diff \$orig_head
242 merge_head=$(sed -e '/ not-for-merge /d' \
243 -e 's/ .*//' "$GIT_DIR"/FETCH_HEAD | \
246 case "$merge_head" in
248 error_on_no_merge_candidates "$@"
251 if test -z "$orig_head"
253 die "$(gettext "Cannot merge multiple branches into empty head")"
255 if test true = "$rebase"
257 die "$(gettext "Cannot rebase onto multiple branches")"
262 if test -z "$orig_head"
264 git update-ref -m "initial pull" HEAD $merge_head "$curr_head" &&
265 git read-tree -m -u HEAD || exit 1
269 if test true = "$rebase"
271 o=$(git show-branch --merge-base $curr_branch $merge_head $oldremoteref)
272 if test "$oldremoteref" = "$o"
278 merge_name=$(git fmt-merge-msg $log_arg <"$GIT_DIR/FETCH_HEAD") || exit
281 eval="git-rebase $diffstat $strategy_args $merge_args"
282 eval="$eval --onto $merge_head ${oldremoteref:-$merge_head}"
285 eval="git-merge $diffstat $no_commit $edit $squash $no_ff $ff_only"
286 eval="$eval $log_arg $strategy_args $merge_args $verbosity $progress"
287 eval="$eval \"\$merge_name\" HEAD $merge_head"